commit 2bdb3d2ee19a6ac61da0a398b10db380e9c92959
Author: Denis Kaganovich <mahatma@eu.by>
Date:   Thu Oct 20 22:01:39 2016 +0200

    configure: accept __stack_chk_fail_local for ssp support too [BZ #20662]
    
    When glibc is compiled with gcc 6.2 that has been configured with
    --enable-default-pie and --enable-default-ssp, the configure script
    fails to detect that the compiler has ssp turned on by default when
    being built for i686-linux-gnu.
    
    This is because gcc is emitting __stack_chk_fail_local but the
    script is only looking for __stack_chk_fail.  Support both.
    
    Example output:
    checking whether x86_64-pc-linux-gnu-gcc -m32 -Wl,-O1 -Wl,--as-needed
    implicitly enables -fstack-protector... no
    
    (cherry picked from commit c7409aded44634411a19b0b7178b7faa237835e6)

diff --git a/ChangeLog b/ChangeLog
index a51771c976..1e2dcea203 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,12 @@
+2016-11-15  Denis Kaganovich  <mahatma@eu.by>
+	    Magnus Granberg  <zorry@gentoo.org>
+	    Mike Frysinger  <vapier@gentoo.org>
+
+	[BZ #20662]
+	* configure.ac (libc_cv_predef_stack_protector): Also check for
+	__stack_chk_fail_local symbols.
+	* configure: Regenerated.
+
 2016-11-03  Joseph Myers  <joseph@codesourcery.com>
 
 	* conform/Makefile ($(linknamespace-header-tests)): Also depend on
diff --git a/configure.ac b/configure.ac
index 33bcd62180..8277d9f727 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1626,12 +1626,14 @@ echo >&AS_MESSAGE_LOG_FD "libc_undefs='$libc_undefs'"
 # symbols (resolved by the linker), so filter out unknown symbols.
 # This will fail to produce the correct result if the compiler
 # defaults to -fstack-protector but this produces an undefined symbol
-# other than __stack_chk_fail.  However, compilers like that have not
-# been encountered in practice.
-libc_undefs=`echo "$libc_undefs" | egrep '^(foobar|__stack_chk_fail)$'`
+# other than __stack_chk_fail or __stack_chk_fail_local. However,
+# compilers like that have not been encountered in practice.
+libc_undefs=`echo "$libc_undefs" | \
+  egrep '^(foobar|__stack_chk_fail|__stack_chk_fail_local)$'`
 case "$libc_undefs" in
 foobar) libc_cv_predef_stack_protector=no ;;
 '__stack_chk_fail
+foobar'|'__stack_chk_fail_local
 foobar') libc_cv_predef_stack_protector=yes ;;
 *) AC_MSG_ERROR([unexpected symbols in test: $libc_undefs]) ;;
 esac],

